#ifndef EXAMPLESOURCELINE_H
#define EXAMPLESOURCELINE_H

#include "SourceLine.h"

/**
 * Example implementation of a source line
 */
class ExampleSourceLine : public SourceLine
{
public:
	ExampleSourceLine(const char *name);
	~ExampleSourceLine();
	DEV_ERR_CODE Open();
	DEV_ERR_CODE Close();
	DEV_ERR_CODE Start();
	DEV_ERR_CODE Stop();
	DEV_ERR_CODE Read(char bytes[], uint32 numBytes, bool8 isSigned, uint32 *numRead);
	DEV_ERR_CODE GetNumBytesReadable(uint32 *numReadable);
	DEV_ERR_CODE GetNumBytesBuffer(uint32 *numBytes);
	bool8 IsOpen();
	bool8 IsStarted();
	uint32 GetSampleRateHz();
	uint32 GetNumChannels();
	uint32 GetNumBytesPerSample();
	void GetName(char name[], uint32 numChars, uint32 *numCharsRequired);

private:
	const char *name;
	bool8 isStarted;
	bool8 isOpen;
	uint32 numBytesReadable;
};

#endif