#ifndef LINE_H
#define LINE_H

#include "types.h"

/**
 * Line interface
 */
class Line
{
public:
	Line() { };
	~Line() { };
	virtual DEV_ERR_CODE Open() = 0;
	virtual DEV_ERR_CODE Close() = 0;
	virtual DEV_ERR_CODE Start() = 0;
	virtual DEV_ERR_CODE Stop() = 0;
	virtual DEV_ERR_CODE GetNumReadWrite(uint32 *numReadWrite) = 0;
	virtual DEV_ERR_CODE ReadWrite(char bytes[], uint32 numBytes, bool8 isSigned, uint32 *numReadWrite) = 0;
	virtual DEV_ERR_CODE GetNumBytesBuffer(uint32 *numBytes) = 0;
	virtual bool8 IsOpen() = 0;
	virtual bool8 IsStarted() = 0;
	virtual uint32 GetSampleRateHz() = 0;
	virtual uint32 GetNumChannels() = 0;
	virtual uint32 GetNumBytesPerSample() = 0;
	virtual LineType GetType() = 0;
	virtual void GetName(char name[], uint32 numChars, uint32 *numCharsRequired) = 0;
};

#endif