#include "ExampleTargetLine.h"
#include "error_codes.h"
#include "string.h"

static const uint32 NUM_CHANNELS = 2;
static const uint32 SAMPLE_RATE_HZ = 48000;
static const uint32 NUM_BYTES_PER_SAMPLE = 2;

ExampleTargetLine::ExampleTargetLine(const char *name)
{	
	this->name = name;
	this->isOpen = FALSE;
	this->isStarted = FALSE;
	this->numBytesWritable = 0;
}
ExampleTargetLine::~ExampleTargetLine()
{
}

DEV_ERR_CODE ExampleTargetLine::Open()
{
	// PUT YOUR CODE HERE
	isOpen = TRUE;
	return NO_ERROR;
}
DEV_ERR_CODE ExampleTargetLine::Close()
{
	// PUT YOUR CODE HERE
	isOpen = FALSE;
	return NO_ERROR;
}

DEV_ERR_CODE ExampleTargetLine::Start()
{
	// PUT YOUR CODE HERE
	isStarted = TRUE;
	return NO_ERROR;
}

DEV_ERR_CODE ExampleTargetLine::Stop()
{
	// PUT YOUR CODE HERE
	isStarted = FALSE;
	return NO_ERROR;
}

DEV_ERR_CODE ExampleTargetLine::GetNumBytesWritable(uint32 *numWritable)
{
	if (!IsOpen())
	{
		return DEVICE_NOT_OPENED;
	}
	// PUT YOUR CODE HERE

	// EXAMPLE:
	*numWritable = this->numBytesWritable;
	this->numBytesWritable += 10000;
	uint32 numBuffer;
	GetNumBytesBuffer(&numBuffer);
	if (this->numBytesWritable > numBuffer)
	{
		this->numBytesWritable = numBuffer;
	}
	return NO_ERROR;
}

DEV_ERR_CODE ExampleTargetLine::Write(char bytes[], uint32 numBytes, bool8 isSigned, uint32 *numWritten)
{
	if (!IsOpen())
	{
		return DEVICE_NOT_OPENED;
	}
	if (!IsStarted())
	{
		return DEVICE_NOT_STARTED;
	}

	// PUT YOUR CODE HERE

	// EXAMPLE:
	if (this->numBytesWritable >= numBytes)
	{
		*numWritten = numBytes;
		this->numBytesWritable -= numBytes;
	}
	else
	{
		*numWritten = 0;
	}
	return NO_ERROR;
}

DEV_ERR_CODE ExampleTargetLine::GetNumBytesBuffer(uint32 *numBytes)
{
	if (!IsOpen())
	{
		return DEVICE_NOT_OPENED;
	}
	// PUT YOUR CODE HERE

	// EXAMPLE:
	*numBytes = 10000000;
	return NO_ERROR;
}

uint32 ExampleTargetLine::GetSampleRateHz()
{
	return SAMPLE_RATE_HZ;
}

uint32 ExampleTargetLine::GetNumChannels()
{
	return NUM_CHANNELS;
}

bool8 ExampleTargetLine::IsOpen()
{
	return isOpen;
}

bool8 ExampleTargetLine::IsStarted()
{
	return isStarted;
}

uint32 ExampleTargetLine::GetNumBytesPerSample()
{
	return NUM_BYTES_PER_SAMPLE;
}

void ExampleTargetLine::GetName(char name[], uint32 numChars, uint32 *numCharsRequired)
{
	*numCharsRequired = (uint32)strlen(this->name)+1; // +1 Add zero delimiter '\0'
	if (numChars > *numCharsRequired)
	{
		numChars = *numCharsRequired;
	}
	strncpy(name, this->name, numChars);
}